#!/bin/bash
#
# Script to convert a mp4 file into a raw audio file and a bunch of vector files
# Needs mplayer, imagemagick, potrace and sox
#
mp4="Touhou-Bad_Apple.mp4"

if [ "$1" = "clean" ]; then
	rm -rf png pnm vec
fi

if [ ! -e png ] || [ ! -e audiodump.wav ]; then
	mkdir png
	cd png
	mplayer -ao pcm:fast -vo png "../$mp4" -benchmark
	mv audiodump.wav ..
	cd ..
fi

if [ ! -e pnm ]; then
	mkdir pnm
	cd png
	for x in *; do 
		echo "Converting $x.."
		convert $x ../pnm/${x%.png}.pnm;
	done
	cd ..
fi

if [ ! -e vec ]; then
	mkdir vec
	cd pnm
	for x in *; do
		echo "Converting $x.."
		potrace -a 0  -O 1 -b geojson -o ../vec/${x%.pnm}.vec $x
	done
	cd ..
fi

#Audio:
#Vectrex: 390 samples per 2 Vblanks, 60Hz VBlank
#390*(60/2)=11700 Hz sample rate
if [ ! -e audiodump.raw ]; then
	sox audiodump.wav -t raw -e signed-integer -b 8 -c 1 -r 11700 audiodump.raw gain -1
fi

./combine.php > vec.bin